/*

Template: ARexxPort/A, Device/A/M
      Eg: DOPUS.1 PS0: PC0: DF0:

$VER: DevDetective.DOpus V1.0 (30-Jul-95) Allan 'Duff' Odgaard
*/

Call AddLib("rexxsupport.library",0,-30,0)
If Show('p','DevDetectivePort') = 1 Then Exit
OpenPort('DevDetectivePort')

Parse Arg PortName Dev.1 Dev.2 Dev.3 Dev.4 Dev.5 Dev.6 .
If Show('p',PortName) = 0 Then Exit

Address(PortName)
Options Results
FailAt 21

Do n = 1 to 6
If Dev.n = '' Then Signal Out
Call Check(Dev.n)
End

Out:	Close('DevDetectivePort')
	Exit

Check:	Parse Arg Device
	Address Command 'Info 'Device' >T:DevDetective.INF'

	Open('Info','T:DevDetective.INF','R')
	a = ReadLn('Info');a = ReadLn('Info');a = ReadLn('Info')
	InfoTxt = ReadLn('Info')
	Close('Info')
	Delete 'T:DevDetective.INF'

	InfoTxt = Right(InfoTxt,Length(InfoTxt)-10)
	If InfoTxt = 'Unreadable disk' Then Return

	Status 3
	ActiveWin = Result

	Status 13 ActiveWin
	CurrentPath = Result

	Status 13 1-ActiveWin
	OtherPath = Result

	If Left(CurrentPath,Length(Device)) = Device Then Status 13 ActiveWin Set Device
	If Left(OtherPath,Length(Device)) = Device Then Status 13 1-ActiveWin Set Device

	If Left(CurrentPath,Length(Device)) = Device | Left(OtherPath,Length(Device)) = Device Then Return

	lf = '0a'x
	Query ScreenName
	PubScreen = Result

	Call AddLib("rexxreqtools.library",0,-30,0)
	DOpusToFront
	Busy On
	Call rtezrequest("A new disk has been inserted in drive "Device || lf"Do you want to read this disk?","_Left Window|_Right Window|_Cancel","Directory Opus Request","RTEz_Flags=EZReqF_CenterText RT_ReqPos=ReqPos_CenterScr RT_PubScrName="PubScreen)
	Busy Off

	If RTResult = 0 Then Return
	Status 3 Set RTResult-1
	Status 13 RTResult-1 Set Device

	Return
